<?php
///////////////////////////////////////////////////////////////////////////
require_once 'utils.php';

class Cursor
{

	    private $m_feed;
	    private $m_feed_url;
	    private $m_items_count;
        private $m_last_ref;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($media_url)
    {
        if ($media_url === 'main_menu:fav')
            $this->m_feed_url = 'main_menu:fav';
        else
            HD::decode_user_data($media_url, $media_str, $this->m_feed_url);

        $this->m_items_count = 0;
        $this->m_feed = 0;
        $this->m_last_ref = "";
    }

    private function parse_page($url)
    {
        $api = HOST_API_URL;
        
        $items = array();

        $doc = HD::http_get_document($url);

        $videos = explode('<a class="downgif"', $doc);
        unset($videos[0]);
        $videos = array_values($videos);

        foreach($videos as $video)
        {
            $tmp = strstr($video, '/torrent/');
            if ($tmp == false)
                continue;
            $season_ref = str_remove_spec(strstr($tmp, '"', true));
            
            $season_image = 'plugin_file://skins/torrent.png';
			//$season_image = '';
			
            $video=str_replace('</a></td> <td align="right">','</a></td> <td ht">',$video);
			$tmp = explode('<td align="right">', $video);
            if (count($tmp) < 2)
                continue;
			$tmp=str_replace('&nbsp;','',$tmp);
            $season_title1 = str_remove_spec(strstr($tmp[1], '</td><td align="center">', true));
			
			$video=str_replace('"><','><',$video);
            $tmp = explode('">', $video);
            if (count($tmp) < 2)
                continue;
			$tmp=str_replace('&#039;','',$tmp);
			$tmp=str_replace('&amp;','&',$tmp);
            $season_title2 = str_remove_spec(strstr($tmp[1], ' </a></td>', true));
			
			$season_title = $season_title2 . " === " . $season_title1;
			$season_title=str_replace('&quot;','',$season_title);
            
            //hd_print("--->>> season_ref: $season_ref");
            //hd_print("--->>> season_title: $season_title");
            //hd_print("--->>> season_image: $season_image");
            
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                        'season_image' => $season_image,
                        'is_has_new' => false
                    )
                )
            );
            ++$this->m_items_count;
        }
        
        return $items;
    }

    private function parse_subcategory()
    {
        hd_print("--> parse subcategory: started...");
        $subcategory = $this->m_feed_url;
        $ref = $subcategory->subcategory_ref;
        $api = HOST_API_URL;
        
        $url = $api . '/browse/0' . $ref;
  //      hd_print("url--->>>: $url");
        if ($this->m_feed > 0)
            $url =$api . '/browse/0' . (($this->m_feed + 1) - 1). $ref ;
//			hd_print("url+1--->>>: $url");
        return $this->parse_page($url);
    }

    ///////////////////////////////////////////////////////////////////////
    private function parse_search_result($search)
    {
        hd_print("--> parse search result: started... $search");
        $api = HOST_API_URL;
        $ref = "/search/" . $search;
	//	hd_print("url--->>>: $url");
        if ($this->m_feed > 0)
            $ref = '/search/' . (($this->m_feed + 1) - 1) . '/0/000/0/'. $search;
    //    hd_print("url+1--->>>: $url");
        $url = $api . $ref;

        return $this->parse_page($url);
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_next_fav(&$plugin_cookies)
    {
        hd_print("--> get favorites: started... $this->m_feed");
        
        $fav_items = isset($plugin_cookies->fav_items) ? $plugin_cookies->fav_items : '';
        
        $ref = "";
        
        $n = 0;
        foreach (ListUtil::string_to_list($fav_items) as $item)
        {
            if ($item == "")
                continue;
            
            if ($n == $this->m_feed)
            {
                $ref = $item;
            }

            ++$n;
            
        }

        if ($ref == "")
            return false;
        
        $items = array();

        $c = VideoCache::get($ref);
        if (!is_null($c))
        {
            array_push
            (
                $items,
                $c
            );

            ++$this->m_items_count;

            return $items;
            
        }

        $api = HOST_API_URL;
        
        $url = $api . $ref;
       // hd_print("url--->>>: $url");
        $doc = HD::http_get_document($url);
		
        $tmp = strstr($doc, '<div id="menu_right_side"></div>');
        $info_block = strstr($tmp, '<td class="header" nowrap="nowrap">', true);
        // hd_print("info_block--->>> $info_block");
        // title
        $tmp = explode('<h1>', $info_block);
        $season_title = str_remove_spec(strstr($tmp[1], '</h1>', true));
        
        // image
        $season_image = 'plugin_file://skins/torrent.png';

        $episode_ref = '';
        $is_has_new = '';        
         
        
        array_push
        (
            $items,
            HD::encode_user_data
            (
                array
                (
                    'video_id' => $ref,
                    'season_title' => $season_title,
                    'season_ref' => $ref,
                    'season_image' => $season_image,
                    'is_has_new' => $is_has_new
                )
            )
        );

        ++$this->m_items_count;

        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    public function next_chunk($plugin_cookies)
    {
	    hd_print("--> next_chunk(): started...");

	    $items = array();

        if ($this->m_feed_url === 'main_menu:fav')
        {
            hd_print("--> parse favorites: started...");
            
            $items = $this->get_next_fav($plugin_cookies);
            ++$this->m_feed;

            if ($items === false)
                return false;
            
            return count($items) > 0 ? $items : false;
        }
	    if (HD::has_attribute($this->m_feed_url, 'ser_feed'))
	    {
		    hd_print("--> search: started...");
            
		    $search_text = $this->m_feed_url->ser_feed;
            
            $items = $this->parse_search_result($search_text);
            ++$this->m_feed;
            
		    hd_print("--> search for: " . $search_text);

            if ($items === false)
                return false;
                
            hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
	    }
        else if (HD::has_attribute($this->m_feed_url, 'subcategory_ref'))
        {
           $items = $this->parse_subcategory();
            ++$this->m_feed;

            if ($items === false)
                return false;
                
            hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
        }

        return false;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
